#####################################################################
#
#       Author : Kushal Das
#       Copyright (c)  2007 Kushal Das
#       kushal@fedoraproject.org
#
#####################################################################


import os

def dirwalk(dir):
    "walk a directory tree, using a generator"
    for f in os.listdir(dir):
        fullpath = os.path.join(dir,f)
        if os.path.isdir(fullpath) and not os.path.islink(fullpath):
            for x in dirwalk(fullpath):  # recurse into subdir
                yield x
        else:
            yield fullpath

def parsefile(f, text):
    """To parse a po file and get particular text"""
    pofile = open(f)
    mesdict = []
    flag = ""
    for line in pofile.readlines():
        line = line.strip()
        if line.startswith("msgid"):
            flag = " ".join(line.split(" ")[1:])
        elif line.startswith('msgstr'):
            mes = unicode(line[7:],'utf8')
            #print mes
            if flag.find(text) != -1:
                mesdict.append((flag,mes))
    return mesdict

def getpofile(path):
    """To get all .po file names"""
    pofiles = []
    for x in dirwalk(path):
        if x.endswith(".po"):
            pofiles.append(x)
    return pofiles


def findtext(files, text):
    """Find the text in the list of files"""
    details = []
    for f in files:
        x = parsefile(f,text)
        if x:
            details.append((f,x))
    return details
